main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
    path('daftar/', views.daftar, name = 'daftar'),
]

story6/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('story7/', include('story7.urls')),
    path('story8/', include('story8.urls')),
    path('story9/', include('story9.urls')),
]

story7/urls.py
from django.urls import include, path
from . import views

app_name = 'story7'

urlpatterns = [
    path('', views.story7, name='story7'),
]

story8/urls.py
from django.urls import include, path
from . import views

app_name = 'story8'

urlpatterns = [
    path('', views.story8, name='story8'),
    path('data_buku/', views.caribuku),
]

story9/urls.py
from django.urls import include, path
from . import views

app_name = 'story9'

urlpatterns = [
    path('', views.story9, name='story9'),
     path('login/', views.login_story9, name ='login'),
     path('logout/',views.logout_story9, name='logout'),
     path('register/', views.register, name='register'),
     path('notLogin/', views.register, name='notLogin'),
]

main/models.py
from django.db import models

# Create your models here.

story7/models.py
from django.db import models

# Create your models here.

story8/models.py
from django.db import models

# Create your models here.

story9/models.py
from django.db import models

# Create your models here.

story9/forms.py
from django import forms

class loginForm(forms.Form):
    username = forms.CharField(widget=forms.TextInput(attrs={'class': 'form-control', 'type' : 'text', 'placeholder' : 'Username' , 'required' : True,}))
    password = forms.CharField(widget=forms.TextInput(attrs={'class' : 'form-control', 'type' : 'password', 'placeholder' : 'Password' , 'required' : True,}))

class registerForm(forms.Form):
    username = forms.CharField(widget=forms.TextInput(attrs={'class': 'form-control', 'type' : 'text', 'placeholder' : 'Username' , 'required' : True,}))
    email = forms.CharField(widget=forms.TextInput(attrs={'class': 'form-control', 'type' : 'text', 'placeholder' : 'Email' , 'required' : True,}))
    password = forms.CharField(widget=forms.TextInput(attrs={'class' : 'form-control', 'type' : 'password', 'placeholder' : 'Password' , 'required' : True,}))

main/views.py
from django.shortcuts import render


def home(request):
    return render(request, 'home.html')
def daftar(request):
    return render(request, 'daftar.html')

story7/views.py
from django.shortcuts import render

def story7(request):
    return render(request, 'story7.html')

story8/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect, JsonResponse

def story8(request):
    return render(request, 'story8.html')

def caribuku(request):
    arg = request.GET['q']
    url_data = 'https://www.googleapis.com/books/v1/volumes?q=' + arg
    result = requests.get(url_data)
    data = json.loads(result.content)
    return JsonResponse(data, safe=False)

story9/views.py
from django.shortcuts import render, redirect
from .forms import loginForm, registerForm
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.models import User

def story9(request):
    return render(request, 'story9.html')

def login_story9(request):
    if request.method == "POST":
        form = loginForm(request.POST)
        if form.is_valid():
            input_username = form.cleaned_data['username']
            input_password = form.cleaned_data['password']
            user = authenticate(request, username = input_username, password = input_password)
            if user is not None:
                login(request, user)
                return redirect('/story9/')
            else:
                return redirect('/story9/register/')
    else:
        form = loginForm()
        response = {'form' : form}
        return render(request, "login.html", response)

def logout_story9(request):
    logout(request)
    return redirect('/story9/')

def register(request):
    if request.method == "POST":
        form = registerForm(request.POST)
        if form.is_valid():
            input_username = form.cleaned_data["username"]
            input_email = form.cleaned_data["email"]
            input_password = form.cleaned_data["password"]
            try:
                user = User.objects.get(username = input_username)
                return redirect("/story9/register/")
            except User.DoesNotExist:
                user = User.objects.create_user(input_username, input_email, input_password)
                return redirect("/story9/login/")
    else:
        form = registerForm()
        response = {'form' : form}
        return render(request, "register.html", response)

main/templates/base.html
{% load static %}
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" crossorigin="anonymous">
    <link  rel="stylesheet" href="{% static 'css/style.css' %}">
    
    {% block style %}
    {% endblock style %}

    {% block title %}<title>Story6</title>{% endblock title %}

    
  </head>
  <body>
    <header>NR</header>

    <nav class="navbar navbar-expand-lg navbar-dark navbar-custom">
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNav">
          <ul class="nav navbar-nav mx-auto">
            <li class="nav-item active">
              <a class="nav-link" href= "{% url 'main:home' %}" style="color: white">story6</a>
            </li>
            <li class="nav-item">
              <a class="nav-link" href="{% url 'story7:story7' %}" style="color: white">Story7</a>
            </li>
            <li class="nav-item">
              <a class="nav-link" href="{% url 'story8:story8' %}" style="color: white">Story8</a>
            </li>
            <li class="nav-item">
              <a class="nav-link" href="{% url 'story9:story9' %}" style="color: white">Story9</a>
            </li>
          </ul>
        </div>
    </nav>

    {% block content %}{% endblock content %}
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    {% block script %}{% endblock script %}
    

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js" integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV" crossorigin="anonymous"></script>
  </body>
</html>

main/templates/daftar.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Hello, world!</title>
{% endblock meta %}

{% block content %}
  <h1>Hello, world!</h1>
{% endblock content %}

main/templates/home.html
{% extends "base.html" %}
{% load static %}

{% block content %}
  <h1>Hello, world!</h1>
{% endblock content %}

main/templates/login.html
{% extends 'story9.html' %}

{% block content %}
<br>
<h3 style="text-align: center;">Login Page</h3><br>
<div class="card col-6 mx-auto" style="background-color:  #1E3C75;">
    <form method="POST">
        {% csrf_token %}
        <br> 
        {{ form.username }}
        <br>
        {{ form.password }}
        <br>
        <button type="submit" class="btn btn-primary" style="background-color:#AD2828; margin: 0 0 15px 0">Login</button>
    </form>
</div>
{% endblock content %}

story7/templates/story7.html
{% extends 'base.html' %}
{% load static %}

{% block script %}
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
<script src="https://code.jquery.com/jquery-1.12.4.js"></script>
<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>

<script>
    $( ".accordion" ).accordion({
        collapsible: true,
        active : false
    })

    function atas($elemen){
        $before = $elemen.prev();
        $elemen.insertBefore($before);
    }
    
    function bawah($elemen){
        $after = $elemen.next();
        $elemen.insertAfter($after);
    }
</script>
{% endblock script %}

{% block content %}
<body>
    <br>
    <h2 style="text-align: center;">About Rara</h2><br>
    <div class="col-9 mx-auto">
        <div class="accordion" id="accordion_1">
            <h3 style="text-align: start"> 
                Activity
                <button type="button" class="btn btn-outline-info" onclick="bawah($('#accordion_1'))" style="background-color:#1E3C75; color: white">v</button>
                <button type="button" class="btn btn-outline-info" onclick="atas($('#accordion_1'))" style="background-color: #1E3C75; color: white">^</button>
            </h3>
            <div>
                <p>
                    Saya adalah seorang mahasiswa Ilmu Komputer di Universitas Indonesia.
                    Saya mahasiswa tingkat 2 yaitu semester 3. Pada semester ini saya mengambil
                    6 mata kuliah yaitu PPW(perancangan dan pemrograman Web), SDA(struktur data
                    dan algoritma), Matematika Dasar 2, Alin(aljabar linear), POK(pengantar
                    organisasi komputer), dan agama. Pada semester ini saya mengikuti kelas
                    perkuliahan dari rumah atau disebut dengan PJJ dikarenakan oleh pandemi yang
                    sedang dihadapi sekarang.
                </p>
            </div>
        </div>
        <div class="accordion" id="accordion_2">
            <h3 style="text-align: start">
                Pengalaman organisasi/kepanitiaan
                <button type="button" class="btn btn-outline-info" onclick="bawah($('#accordion_2'))" style="background-color: #1E3C75; color: white;">v</button>
                <button type="button" class="btn btn-outline-info" onclick="atas($('#accordion_2'))" style="background-color: #1E3C75; color: white">^</button>
            </h3>
            <div>
                <p>
                Selama kuliah saya tidak pernah mengikuti organisasi maupun kepanitiaan,
                karena menurut saya, saya bukan orang yang dapat mengatur waktu dengan baik,
                sehingga saya takut apabila saya mengikuti organisasi atau kepanitiaan tugas
                kuliah saya akan terbengkalai sehingga saya memilih untuk tidak mengikuti organisasi atau kepanitiaan.
                </p>
            </div>
        </div>
        <div class="accordion" id="accordion_3">
            <h3 style="text-align: start">
                Prestasi
                <button type="button" class="btn btn-outline-info" onclick="bawah($('#accordion_3'))" style="background-color: #1E3C75; color: white">v</button>
                <button type="button" class="btn btn-outline-info" onclick="atas($('#accordion_3'))"  style="background-color: #1E3C75; color: white">^</button>
            </h3>
            <div>
                <p>
                Saya tidak memiliki banyak prestasi dalam perlombaan karena jika ditawarkan untuk mengikuti lomba
                saya selalu menolaknya sehingga semenjak smp saya sudah tidak pernah mengikuti lomba.
                </p>
            </div>
        </div>
        <div class="accordion" id="accordion_4">
            <h3 style="text-align: start">
                Hobby
                <button type="button" class="btn btn-outline-info" onclick="bawah($('#accordion_4'))" style="background-color: #1E3C75; color: white">v</button>
                <button type="button" class="btn btn-outline-info" onclick="atas($('#accordion_4'))"  style="background-color: #1E3C75; color: white">^</button>
            </h3>
            <div>
                <p>
                Saya sangat suka mengisi waktu luang dengan menonton film maupun
                bermain game, sejak kecil saya sangat suka bermain game console seperti nintendo.
                Saya juga memiliki ketertarikan pada dunia sneakers sejak lama, dan sejak kuliah
                pjj, saya mulai menyukai untuk membuat aquascape.
                </p>
            </div>
        </div>
    </div>
</body>
{% endblock content %}

story8/templates/story8.html
{% extends 'base.html' %}
{% load static %}

{% block content %}
<br><h2 style="text-align: center;">Data Buku</h2><br>
<div class="box" style="text-align: center">
    <input id="keyword" placeholder="Masukkan keyword"> 
</div>
<br>
<table class="table table-bordered mx-auto" style="width: 75%; background: #1E3C75; color: white; text-align: center">
    <thead>
    <tr>
        <th>Title</th>
        <th>Author</th>
        <th>Publish Date</th>
    </tr>
    </thead>
    <tbody id="hasil_search">
    </tbody>
</table>
{% endblock content %}


{% block script %}
<script type="text/javascript">
    $("#keyword").keyup(function(){
        var isi = $("#keyword").val();
        var url_panggil = 'https://www.googleapis.com/books/v1/volumes?q=' + isi;
        $.ajax({
            url: url_panggil,
            success: function(hasil){
                console.log(hasil.items);
                var result = $("#hasil_search");
                result.empty();

                for(i = 0; i < hasil.items.length; i++){
                    var title = hasil.items[i].volumeInfo.title;
                    var authors = hasil.items[i].volumeInfo.authors;
                    var date = hasil.items[i].volumeInfo.publishedDate;
                    console.log(title);
                    result.append("<tr> <td>" + title + "</td>" + "<td>" + authors + "</td>" + "<td>" + date + "</td>");
                }
            } 
        })
    })
</script>
{% endblock script %}

story9/templates/login.html
{% extends 'story9.html' %}

{% block content %}
<br>
<h3 style="text-align: center;">Login Page</h3><br>
<div class="card col-6 mx-auto" style="background-color:  #1E3C75;">
    <form method="POST">
        {% csrf_token %}
        <br> 
        {{ form.username }}
        <br>
        {{ form.password }}
        <br>
        <button type="submit" class="btn btn-primary" style="background-color:#AD2828; margin: 0 0 15px 0">Login</button>
    </form>
</div>
{% endblock content %}

story9/templates/register.html
{% extends 'story9.html' %}

{% block content %}
<br>
<h3 style="text-align: center;">Sign Up Page</h3><br>
<div class="card col-9 mx-auto" style="background-color:  #1E3C75;">
    <br>
    <form method="POST">
        {% csrf_token %}
        {{ form.username }}
        <br>
        {{ form.email }}
        <br>
        {{ form.password }}
        <br><br>
        <button type="submit" class="btn btn-primary" style="background-color:#AD2828; margin: 0 0 15px 0">Sign Up</button>
    </form>
</div>
{% endblock content %}

story9/templates/story9.html
{% load static %}
<!doctype html>
<html lang="en">
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" crossorigin="anonymous">
    <link  rel="stylesheet" href="{% static 'css/style.css' %}">
    
    {% block style %}
    {% endblock style %}

    {% block title %}<title>Story9</title>{% endblock title %}

</head>
<body>
    <header>NR</header>

    <nav class="navbar navbar-expand-lg navbar-dark navbar-custom">
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="nav navbar-nav mx-auto">
                <li class="nav-item active">
                    <a class="nav-link" href= "{% url 'main:home' %}" style="color: white">story6</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'story7:story7' %}" style="color: white">Story7</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'story8:story8' %}" style="color: white">Story8</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'story9:story9' %}" style="color: white">Story9</a>
                </li>
            </ul>

            {% if user.is_authenticated %}
            <ul class="nav navbar-nav navbar-right">
                <li class="nav-item">
                    <a class="nav-link" href="#" style="color: white">Welcome, {{ user.get_username }}</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'story9:logout' %}" style="color: white">LOGOUT</a>
                </li>
            </ul>
            {% else %}
            <ul class="nav navbar-nav navbar-right">
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'story9:register' %}" style="color: white">SIGN UP</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href= "{% url 'story9:login' %}" style="color: white">LOGIN</a>
                </li>
            </ul>
            {% endif %}
      </div>
    </nav>

{% block content %}{% endblock content %}

{% block script %}{% endblock script %}
  

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js" integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV" crossorigin="anonymous"></script>
</body>
</html>